import type { CliPlugin, ModuleTools, ICompiler } from '@modern-js/module-tools';
export interface NodePolyfillPluginOptions {
    excludes?: string[];
    overrides?: Partial<Record<keyof typeof modules, string>>;
}
export declare const modules: {
    assert: string;
    buffer: string;
    child_process: null;
    cluster: null;
    console: string;
    constants: string;
    crypto: string;
    dgram: null;
    dns: null;
    domain: string;
    events: string;
    fs: null;
    http: string;
    https: string;
    module: null;
    net: null;
    os: string;
    path: string;
    punycode: string;
    process: string;
    querystring: string;
    readline: null;
    repl: null;
    stream: string;
    _stream_duplex: string;
    _stream_passthrough: string;
    _stream_readable: string;
    _stream_transform: string;
    _stream_writable: string;
    string_decoder: string;
    sys: string;
    timers: string;
    tls: null;
    tty: string;
    url: string;
    util: string;
    vm: string;
    zlib: string;
};
export declare const getNodePolyfillHook: (polyfillOption?: NodePolyfillPluginOptions) => {
    name: string;
    apply(compiler: ICompiler): void;
};
export declare const modulePluginNodePolyfill: (polyfillOption?: NodePolyfillPluginOptions) => CliPlugin<ModuleTools>;
