"use strict";
var __create = Object.create;
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getProtoOf = Object.getPrototypeOf;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toESM = (mod, isNodeMode, target) => (target = mod != null ? __create(__getProtoOf(mod)) : {}, __copyProps(
  // If the importer is in node compatibility mode or this is not an ESM
  // file that has been converted to a CommonJS file using a Babel-
  // compatible transform (i.e. "__esModule" has not been set), then set
  // "default" to the CommonJS "module.exports" for node compatibility.
  isNodeMode || !mod || !mod.__esModule ? __defProp(target, "default", { value: mod, enumerable: true }) : target,
  mod
));
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);
var src_exports = {};
__export(src_exports, {
  getNodePolyfillHook: () => getNodePolyfillHook,
  modulePluginNodePolyfill: () => modulePluginNodePolyfill,
  modules: () => modules
});
module.exports = __toCommonJS(src_exports);
var import_path = __toESM(require("path"));
var import_utils = require("./utils");
const modules = {
  assert: require.resolve("assert/"),
  buffer: require.resolve("buffer/"),
  child_process: null,
  cluster: null,
  console: require.resolve("console-browserify"),
  constants: require.resolve("constants-browserify"),
  crypto: require.resolve("crypto-browserify"),
  dgram: null,
  dns: null,
  domain: require.resolve("domain-browser"),
  events: require.resolve("events/"),
  fs: null,
  http: require.resolve("stream-http"),
  https: require.resolve("https-browserify"),
  module: null,
  net: null,
  os: require.resolve("os-browserify/browser"),
  path: require.resolve("path-browserify"),
  punycode: require.resolve("punycode/"),
  process: require.resolve("process/browser"),
  querystring: require.resolve("querystring-es3"),
  readline: null,
  repl: null,
  stream: require.resolve("stream-browserify"),
  _stream_duplex: require.resolve("readable-stream/lib/_stream_duplex"),
  _stream_passthrough: require.resolve("readable-stream/lib/_stream_passthrough"),
  _stream_readable: require.resolve("readable-stream/lib/_stream_readable"),
  _stream_transform: require.resolve("readable-stream/lib/_stream_transform"),
  _stream_writable: require.resolve("readable-stream/lib/_stream_writable"),
  string_decoder: require.resolve("string_decoder/"),
  sys: require.resolve("util/"),
  timers: require.resolve("timers-browserify"),
  tls: null,
  tty: require.resolve("tty-browserify"),
  url: require.resolve("url/"),
  util: require.resolve("util/"),
  vm: require.resolve("vm-browserify"),
  zlib: require.resolve("browserify-zlib")
};
const getNodePolyfillHook = (polyfillOption = {}) => {
  var _polyfillOption_excludes;
  const polyfillModules = {
    ...(0, import_utils.excludeObjectKeys)((0, import_utils.addResolveFallback)(modules, polyfillOption.overrides), (_polyfillOption_excludes = polyfillOption.excludes) !== null && _polyfillOption_excludes !== void 0 ? _polyfillOption_excludes : [])
  };
  const polyfillModulesKeys = Object.keys(polyfillModules);
  return {
    name: "node-polyfill",
    apply(compiler) {
      const plugins = [
        {
          name: "example",
          setup(build) {
            build.onResolve({
              filter: /.*/
            }, (args) => {
              if (polyfillModulesKeys.includes(args.path)) {
                return {
                  path: polyfillModules[args.path]
                };
              }
              return void 0;
            });
          }
        }
      ];
      const lastBuildOptions = compiler.buildOptions;
      var _lastBuildOptions_inject, _lastBuildOptions_plugins;
      compiler.buildOptions = {
        ...lastBuildOptions,
        inject: [
          ...(_lastBuildOptions_inject = lastBuildOptions.inject) !== null && _lastBuildOptions_inject !== void 0 ? _lastBuildOptions_inject : [],
          import_path.default.join(__dirname, "globals.js")
        ],
        plugins: [
          plugins[0],
          ...(_lastBuildOptions_plugins = lastBuildOptions.plugins) !== null && _lastBuildOptions_plugins !== void 0 ? _lastBuildOptions_plugins : []
        ]
      };
    }
  };
};
const modulePluginNodePolyfill = (polyfillOption = {}) => ({
  name: "@modern-js/plugin-module-node-polyfill",
  setup() {
    return {
      beforeBuildTask(config) {
        const hook = getNodePolyfillHook(polyfillOption);
        config.hooks.push(hook);
        return config;
      }
    };
  }
});
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {
  getNodePolyfillHook,
  modulePluginNodePolyfill,
  modules
});
