"use strict";
var __create = Object.create;
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getProtoOf = Object.getPrototypeOf;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toESM = (mod, isNodeMode, target) => (target = mod != null ? __create(__getProtoOf(mod)) : {}, __copyProps(
  // If the importer is in node compatibility mode or this is not an ESM
  // file that has been converted to a CommonJS file using a Babel-
  // compatible transform (i.e. "__esModule" has not been set), then set
  // "default" to the CommonJS "module.exports" for node compatibility.
  isNodeMode || !mod || !mod.__esModule ? __defProp(target, "default", { value: mod, enumerable: true }) : target,
  mod
));
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);
var utils_exports = {};
__export(utils_exports, {
  addResolveFallback: () => addResolveFallback,
  excludeObjectKeys: () => excludeObjectKeys
});
module.exports = __toCommonJS(utils_exports);
var import_path = __toESM(require("path"));
function filterObject(object, filter) {
  const filtered = {};
  Object.keys(object).forEach((key) => {
    if (filter(key)) {
      filtered[key] = object[key];
    }
  });
  return filtered;
}
function excludeObjectKeys(object, keys) {
  return filterObject(object, (key) => !keys.includes(key));
}
function addResolveFallback(object, overrides = {}) {
  const keys = Object.keys(object);
  const newObject = {};
  for (const key of keys) {
    if (object[key] === null) {
      newObject[key] = import_path.default.join(__dirname, `./mock/${key}.js`);
    } else {
      newObject[key] = object[key];
    }
  }
  const overridesKeys = Object.keys(overrides);
  for (const key of overridesKeys) {
    if (overrides[key]) {
      newObject[key] = overrides[key];
    }
  }
  return newObject;
}
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {
  addResolveFallback,
  excludeObjectKeys
});
